

RequireFile("perm-mat-group.gap");

# generic cube for any dimension

CubeVerts:=function(d)
    return List(Tuples([-1,1],d),v->Concatenation([1],v));
end;

#reflection matrix, lifted into homogeneous coordinates
reflectionMat:=function(i,dim)
    local v;
    v:=List([1..dim+1], function (j) if i+1= j then
        return -1; else return 1; fi; end);
        return DiagonalMat(v);
end;        

# shift a permutation so it works on the 
shiftPerm:=function(pi,dim)
    return MappingPermListList([2..dim+1],
                                Permuted([2..dim+1],pi));
end;
    
orthoRotationMats:=function(dim)
    return List(GeneratorsOfGroup(SymmetricGroup(dim)),
                pi->PermutationMat(shiftPerm(pi,dim),dim+1));
end;


orthoMatGroup:=function(dim)
    return Group(Concatenation(orthoRotationMats(dim),
                   List([1..dim],j->reflectionMat(j,dim))));
end;

orthoRotMatGroup:=function(dim)
    return Group(orthoRotationMats(dim));
end;

orthoPermGroup:=function(dim)
    return PermGroupMatGroup(orthoMatGroup(dim),CubeVerts(dim));
end;

orthoRotPermGroup:=function(dim)
    return PermGroupMatGroup(orthoRotMatGroup(dim),CubeVerts(dim));
end;

