RequirePackage("require_file");
AddToLoadPath("~/research/symbal/src");
AddToLoadPath("../cube");

ReadFile("cube.gap");
ReadFile("perturb.gap");
ReadFile("ratio.gap");

SetInfoLevel(InfoRatio,3);
dim:=4;

V:=CubeVerts(dim);
G:=orthoPermGroup(dim);


H:=bestLineStabilizer(G,V);
O:=sortedOrbits(H,[1..Size(V)]);

sigma:=List([1..Size(O)],p->-1);
sys:=lslackSys(V);

cobs:= [[ 5, 13, 15, 16 ],
        [ 9, 11, 15, 16 ],
        [ 9, 13, 14, 16 ],
        [ 1, 9, 13, 15 ],
        [ 5, 13, 15, 16 ],
        [ 9, 11, 15, 16 ],
        [9,13,15,16] ];

dict:=lrsdict([9,13,15,16],sys);

Print(lorbitEntering(dict,O,sigma));

#for C in cobs do
#    dict:=rawdict(C,sys);
#    Print("Starting cobasis ",C, "=> ", orbitEntering(dict,O,sigma),"\n");
#od;
    


