RequirePackage("require_file");
AddToLoadPath("~/research/symbal/src");
AddToLoadPath("../cut");

ReadFile("dfs.gap");
ReadFile("cut-funcs.gap");
ReadFile("perturb.gap");

globalResults:=rec();

dim:=6;
G:=cutMatGroup(dim);
V:=homogenizeVerts(CutVerts(dim));
PG:=PermGroupMatGroup(G,V);
    
Vp:=[];
results:=[];
for i  in [1..Size(V)] do
    Vp[i]:=orbitLex(V,PG,V[i],DefaultInnerProduct,1/100000000);         
od;
        
  
finished:=false;
for limit in 100*[2,4,8,16,32,64] do
    for i in [1..Size(Vp)] do 
        Print("Direction = ",i," Limit = ",limit,"\n");
        results[i]:=dfs(Vp[i].matrix,Vp[i].group,
                        [ rec(VRepresentation:=false, 
                              basisLimit:=limit,
                              canonTest:=false,
                              cacheSize:=10000,
                              cobasisStabilizers:=false,
                              infoLevel:=1,
                              gramVec:=true,
                              gramGraph:=true,
                              gramMotion:=true,
                              lexOnly:=false,
                              dualFacetTrick:=true,
                                 )]);
        if results[i].finished then
            FormatResults(results[i],"nodes");
            finished:=true;
            break;
        fi;
    od;
    if finished then 
        break;
    fi;
od;


