
RequirePackage("require_file");
AddToLoadPath("~/research/gap-lrslib/src");
AddToLoadPath("../prodcyclic");

ReadFile("dfs.gap");
ReadFile("integerize.gap");

ReadFile("pc4_10.gap");

globalResults:=rec();
doDFS:=function()
    
    ClearProfile();
    ProfileFunctions(dfs,IsNewCobasis,lookupCache,addCache,
            gramEdges,CheckByCanons,FindSymmetry,isIsometry,knownVertex,
            MatchingInvariants,CobasisInvariants,PushNewEdges,gramGraph);

    
    globalResults:=dfs(V,fail,
                       [ rec(VRepresentation:=false, 
                             canonTest:=false,
                             nautyIsometries:=true,
                             cobasisStabilizers:=false,
                             infoLevel:=2,
                             gramVec:=true,
                             gramGraph:=true,
                             gramMotion:=true,
                             gramMotionViaGroup:=false,
                             gramMotionViaBrute:=true,
                             lexOnly:=false
                             )]);
    DisplayProfile();
    Print("{\n dimension =>",4,",\n");
    Print("dfs =>{basis_orbits=>", Size(globalResults.cobasisOrbits),",\n");
    Print("vertex_orbits=>", Size(globalResults.vertexOrbits),",\n");          
    Print("ray_orbits=>", Size(globalResults.rayOrbits),"\n}\n}\n");          
end;
