#proc settings
	encodenames: yes
	enable_suscripts: yes

#set COLORLIST = red,yellow,blue,green,orange,pink,black,white



#proc getdata
fieldnameheader: yes
file: breakdown.tab
#endproc   //necessary in order to do the following computation involving NRECORDS

// compute XMAX (number of records+1 for bar graphs)
#set XMAX = $arith(@NRECORDS+1)  


// set up area
#proc areadef
title: Wreath products of cross polytopes.
titledetails: align=C adjust=0,-0.2
rectangle: 1 1 6 4
xrange: 0 @XMAX
yautorange: datafield=2
yscaletype: log
xaxis.stubs: datafield=1
xaxis.label: dimension

#proc yaxis
selflocatingstubs: text
	10  10ms
	100 100ms
	1000 1s
	10000 10s
	100000 100s
	300000 300s

stubcull: .25
label: cpu time 


// initialize loop variables
#set I = 2
#set NCLUST = $arith(@NFIELDS-1)

// start loop
#loop

  // set vars for this iteration
  #set FNAME = $fieldname(@I)   // this function is new
  #set ICLUST = $arith(@I-1)
  #set COLOR = $nmember(@ICLUST,@COLORLIST)

  // do bars
  #proc bars
  lenfield: @I
  cluster: @ICLUST / @NCLUST
  color: @COLOR
#hideund
  legendlabel: @FNAME
#showund
  barwidth: 0.07

  // update I and see if time to stop..
  #set I = $arith(@I+1)
  #if @I > @NFIELDS
    #break
  #endif
#endloop

#proc legend
  location: min+0.3 max
  reverseorder: yes
  seglen: 0.3


