%{
#include <stdio.h>
#include "lrsserv.h"
#include "thingstack.h"

  static int lineno=0;
  static int string_len;
  static char string_buf[BUFSIZ];

#define STRLENMAX (BUFSIZ-2)
%}
D [0-9]
S [ \t]
%x INSTRING
%%

\"	{ string_len=0; BEGIN(INSTRING); };

<INSTRING>\" {BEGIN(INITIAL); string_buf[string_len]='\0'; 
   push_string(string_buf);
}

<INSTRING>\n  {err_fatal("scanner","unterminated string %s on line %d",string_buf,lineno);};

<INSTRING>[^\"]+        {
        char *p;

	for (p=yytext; *p; p++){
		if (string_len>STRLENMAX) err_fatal("scanner",
		   "String length of %d exceeded at line %d",STRLENMAX,lineno);
		string_buf[string_len++]=*p;
        }
}

\n {lineno++;};
^\#.*$		;		/* ignore  comments */
[\t ]+		;		/* ignore whitespace */	

-?{D}+{S}*\/{S}*{D}+ {dlog("R=>%s",yytext); push_rational(yytext);}
-?{D}+	{ dlog("I=>%s",yytext); push_integer(yytext); }

@ { dlog("M=>@"); push_mark(); };
v_rep { v_rep(); };
h_rep { };
init	{ init(); };
dump_dict { dump_dict(); };
get_dict { get_dict(); };
raw_dict { raw_dict(); };
dump_orbits { dump_orbits(); };
set_row { set_row(); };
set_obj { set_obj(); };
solve_lp { solve_lp(); };
getsolution { getsolution(); };
getfirstbasis { getfirstbasis(); };
getlinearities { getlinearities(); };
getnextbasis { getnextbasis(); };
getcobasis { getcobasis(); };
setcobasis { setcobasis(); };
getvertex { getvertex(); };
allratio { allratio(); };
set_orbits { set_orbits(); };
debug { debug(); };
pivot { dopivot(); };
ipivot { ipivot(); };
geometric { geometric(); };
lexratio { lexratio(); };
set_lex_signs { set_lex_signs(); };
dump_lex_signs { dump_lex_signs(); };
orbitratio { orbitratio(); };
iorbitratio { iorbitratio(); };
initinequality { initinequality(); };
renumberinequality { renumberinequality(); };
<<EOF>> { shutdown(); }
<*>.|\n     { printf("ERROR unmatched char: %s\n",yytext); };
%%

int yywrap(){
  return 1;
}

