#ifndef THINGSTACK_H
#define THINGSTACK_H

#include <stdio.h>
#include "lrslib.h"

typedef enum thing_type_e {THING_STRING, THING_INTEGER, THING_RATIONAL, THING_MARK} thing_type;

typedef struct thing_struct {
  thing_type type;
  char *string;
  lrs_mp_t integer;
  lrs_mp_t denominator;
  struct thing_struct *next;
} *thing_p, *thingstack_p, thing_t;

extern void pop_integer(lrs_mp_t a);
extern int pop_int();
extern void pop();
void pop_rational_vector(lrs_mp_vector num, lrs_mp_vector den, int n);
extern int top_is_mark();
extern void push_string(char*);
#endif
