%{
#include <stdio.h>
#include "nautyserv.h"

  static int lineno=0;
  static int string_len;
  static char string_buf[BUFSIZ];

#define STRLENMAX (BUFSIZ-2)
%}
D [0-9]
S [ \t]
%x INSTRING
%%

\"	{ string_len=0; BEGIN(INSTRING); };

<INSTRING>\" {BEGIN(INITIAL); string_buf[string_len]='\0'; 
   push_string(string_buf);
}

<INSTRING>\n  {err_fatal("scanner","unterminated string %s on line %d",string_buf,lineno);};

<INSTRING>[^\"]+        {
        char *p;

	for (p=yytext; *p; p++){
		if (string_len>STRLENMAX) err_fatal("scanner",
		   "String length of %d exceeded at line %d",STRLENMAX,lineno);
		string_buf[string_len++]=*p;
        }
}

\n {lineno++;};
^\#.*$		;		/* ignore  comments */
[\t ]+		;		/* ignore whitespace */	

-?{D}+{S}*\/{S}*{D}+ {dlog("R=>%s",yytext); push_rational(yytext);}
-?{D}+	{ dlog("I=>%s",yytext); push_integer(yytext); }

dumpgraph { dumpgraph(); }
dumppartition { dumppartition(); }
ident { dlog("ident %d",pop_int()); };
graph { newgraph(); }
nauty { donauty(); }
adjrow {adjrow(); }
colourclass { colourclass(); }
getcanon { getcanon(); };
printautom { push_int(TOK_PRINTAUTOM); };
option { option(); };
rusage { rusage(); };
@ { dlog("M=>@");push_mark();}

<<EOF>> { shutdown(); }

%%

int yywrap(){
  return 1;
}

