#!/usr/bin/env perl

use strict;

my $state=0;
my $CONV=1;
my  $CONE=2;
my @rows=();
my $dim;
my $line;

LINE: while(<>){
  last if (m/^\s*END\s*$/);

  if ($state==0 && m/\s*DIM\s*=\s*(\d+)/){
    $dim=$1;
    next LINE;
  }

  if (m/CONV_SECTION/){
    $state=$CONV;
    next LINE;
  }

  if (m/CONE_SECTION/){
    $state=$CONE;
    next LINE;
  }

  my @coords=split(" ");
  
  if ($state==$CONV){
    $line=join(",",1,@coords);
  } else {
    $line=join(",",0,@coords);
  }
  $line="[".$line."]";

  push(@rows,$line)
}

print 'RequirePackage("require_file");;
AddToLoadPath("~/research/gap-lrslib/src");;

ReadFile("dfs.gap");;
';

print "M:=[";
print join(",\n",@rows);
print "];;\n";

print '
results:=dfs(M,fail,[rec(VRepresentation:=true,nautyIsometries:=true)]);
FormatResults(results,"dimension");
';
