#!/usr/bin/env perl

use Data::Dumper;
use strict;
my $OUT=0;
my $IN=1;

my $state=$OUT;
my $hashstr;
my $output={};

$Data::Dumper::Sortkeys=1;
$Data::Dumper::Terse=1;

LINE: while(<>){
  if (m/^#STARTRESULTS/ && ($state==$OUT)){
    $state=$IN;
    $hashstr="";
    next LINE;
  }
  if (m/^#ENDRESULTS/ && ($state=$IN)){
    $state=$OUT;
    
    my $hash=eval($hashstr);
    my $key;

    if ($hash->{'key'} =~ m/^name:(.*)$/){
      $key=$1;
    } else {
      $key=$hash->{$hash->{key}};
    }
    if (defined($output->{$key})){
      foreach my $item (keys %{$hash}) {
	print STDERR "merging $key\n";
	$output->{$key}->{$item}=$hash->{$item};
      }
      
    } else {
      $output->{$key}=$hash;
    }
    next LINE;
  }

  if ($state==$IN){
    $hashstr.=$_;
  }
}

print Dumper($output);
