
newDictionary:=function()
    return rec(index:=[],data:=[]);
end;


addDictionary:=function(dictionary, key, value)
    local pair,pos,datapos;
    
    key:=Immutable(key);

    if Size(dictionary.index)=0 then
        pos:=fail;
    else
        pos:=PositionFirstComponent(dictionary.index,key);
    fi;
    

    if pos<>fail and (pos>Size(dictionary.index) 
               or dictionary.index[pos][1] <> key) then
        pos:=fail;
    fi;
    
    
    if pos <> fail then
        datapos:=dictionary.index[pos][2];
        Add(dictionary.data[datapos],value);
    else
        datapos:=Size(dictionary.data)+1;
        pair:=[key,datapos];
        MakeImmutable(pair);
        AddSet(dictionary.index,pair);
        dictionary.data[datapos]:=[ value ];
    fi;
    

        

end;



lookupDictionary:=function(dictionary,key)
    local pos;
    
    if Size(dictionary.index)=0 then
        return fail;
    fi;
               
    pos:=PositionFirstComponent(dictionary.index,key);
    if pos=fail then 
        return fail;
    fi;
    if pos<>fail and 
       (pos>Size(dictionary.index) or dictionary.index[pos][1] <> key) then
        return fail;
    fi;
    
    return dictionary.data[dictionary.index[pos][2]];
end;

dictionaryValues:=function(dict)
    return dict.data;
end;

newCache:=function(size)
    return rec(index:=[],  size:=size);
end;

addCache:=function(dictionary, key)
    local pos,dead;
    
    key:=Immutable(key);

    pos:=Position(dictionary.index,key);

    if pos = fail then
        
        if (Size(dictionary.index)>=dictionary.size) then
            dead:=PseudoRandom(dictionary.index);
            RemoveSet(dictionary.index,dead);
        fi;
        AddSet(dictionary.index,key);
    fi;

end;

lookupCache:=function(dictionary,key)
    return Position(dictionary.index,key) <> fail;
end;